(*
    HTMLwv T|[g
*)

unit HTMLHelp;

interface

uses
  Windows, Forms;

const
  HH_DISPLAY_TOPIC        = $0000;
  HH_HELP_FINDER          = $0000;
  HH_DISPLAY_TOC          = $0001;
  HH_DISPLAY_INDEX        = $0002;
  HH_DISPLAY_SEARCH       = $0003;
  HH_SET_WIN_TYPE         = $0004;
  HH_GET_WIN_TYPE         = $0005;
  HH_GET_WIN_HANDLE       = $0006;
  HH_ENUM_INFO_TYPE       = $0007;
  HH_SET_INFO_TYPE        = $0008;
  HH_SYNC                 = $0009;
  HH_RESERVED1            = $000A;
  HH_RESERVED2            = $000B;
  HH_RESERVED3            = $000C;
  HH_KEYWORD_LOOKUP       = $000D;
  HH_DISPLAY_TEXT_POPUP   = $000E;
  HH_HELP_CONTEXT         = $000F;
  HH_TP_HELP_CONTEXTMENU  = $0010;
  HH_TP_HELP_WM_HELP      = $0011;
  HH_CLOSE_ALL            = $0012;
  HH_ALINK_LOOKUP         = $0013;
  HH_GET_LAST_ERROR       = $0014;
  HH_ENUM_CATEGORY        = $0015;
  HH_ENUM_CATEGORY_IT     = $0016;
  HH_RESET_IT_FILTER      = $0017;
  HH_SET_INCLUSIVE_FILTER = $0018;
  HH_SET_EXCLUSIVE_FILTER = $0019;
  HH_INITIALIZE           = $001C;
  HH_UNINITIALIZE         = $001D;
  HH_PRETRANSLATEMESSAGE  = $00FD;
  HH_SET_GLOBAL_PROPERTY  = $00FC;

type
  THH_POPUP = record
    cbStruct: Integer;
    hinst: HINST;
    idString: UINT;
    pszText: LPCTSTR;
    pt: TPoint;
    clrForeground: COLORREF;
    clrBackground: COLORREF;
    rcMargins: TRect;
    pszFont: LPCTSTR;
  end;

function HtmlHelpCommand(Command: UINT; Data: DWORD = 0): HWND;
function HtmlHelpContext(HelpContext: DWORD): HWND;

implementation

function HtmlHelpA(hwndCaller: HWND; pszFile: LPCSTR; uCommand: UINT; dwData: DWORD): HWND;
  stdcall; external 'hhctrl.ocx';

function HtmlHelpCommand(Command: UINT; Data: DWORD = 0): HWND;
begin
  Result := HtmlHelpA(Application.Handle, PChar(Application.HelpFile), Command, Data);
end;

function HtmlHelpContext(HelpContext: DWORD): HWND;
begin
  Result := HtmlHelpCommand(HH_HELP_CONTEXT, HelpContext);
end;

initialization
  HtmlHelpCommand(HH_INITIALIZE);

finalization
  HtmlHelpCommand(HH_UNINITIALIZE);

end.

