(*
        lbg[N]xOt <DuGraph> (IniFile.pas)
            Copyright (C) 2001-05,08-12 IGJ-HMC, all rights reserved.
*)

unit IniFile;

interface

uses
  IniFiles, Graphics{String/Color};

procedure ReadIniFile;
procedure WriteIniFile;

implementation

uses Main, Defines;

procedure ReadIniFile;
begin
  with TIniFile.Create(IniFileName) do begin
    try
      with MainForm do begin
        AdapterName := ReadString(ISC_Setting, 'AdapterName', '');
        GraphRange  := ReadFloat(ISC_Setting, 'GraphRange' , 1000);
        GraphMiddle := ReadFloat(ISC_Setting, 'GraphMiddle', 900);
        GraphSendRange := ReadFloat(ISC_Setting, 'GraphSendRange', 150);
        GraphUnit   := ReadString(ISC_Setting, 'GraphUnit', '0.00k oCg/b');
        ShowValue   := ReadBool(ISC_Setting, 'ShowValue', true);
        LockWindow  := ReadBool(ISC_Setting, 'LockWindow', false);
        SnapWindow  := ReadBool(ISC_Setting, 'SnapWindow', false);
        HideWindow  := ReadBool(ISC_Setting, 'HideWindow', false);
        AlphaBlend  := ReadInteger(ISC_Setting, 'AlphaBlend', 0);
        Interval    := ReadInteger(ISC_Setting, 'Interval', 1000);
        ValueInterval := ReadInteger(ISC_Setting, 'ValueInterval', 1);

        clRecv   := StringToColor(ReadString(ISC_Color, 'Recv'  , 'clBlue'  ));
        clSend   := StringToColor(ReadString(ISC_Color, 'Send'  , 'clRed'   ));
        clMiddle := StringToColor(ReadString(ISC_Color, 'Middle', 'clGray'  ));
        clBack   := StringToColor(ReadString(ISC_Color, 'Back'  , 'clSilver'));
        // {'clLtGray'̂肾AColorToStringł͓Fԍł'clSilver'ԂĂ̂ŁB

        ReadSectionValues(ISC_CustomColor, CustomColors);

        with ValueFont do begin
          Name := ReadString(ISC_Font, 'Name', 'MS UI Gothic');
          Size := ReadInteger(ISC_Font, 'Size', 10);
          Style := TFontStyles(Byte(ReadInteger(ISC_Font, 'Style', 0)));
        end;

        // E͘g̊Ɉˑ̂ŁA݂̒lŏ
        Top    := ReadInteger(ISC_Window, 'Top'   , 32);
        Left   := ReadInteger(ISC_Window, 'Left'  , 32);
        Width  := ReadInteger(ISC_Window, 'Width' , Width);
        Height := ReadInteger(ISC_Window, 'Height', Height);

        // INIp
        // l\̍sԒ
        Inc(ValueLineSpacing[1], ReadInteger(ISC_Setting, 'ValueLineSpacing1', 0));
        Inc(ValueLineSpacing[2], ReadInteger(ISC_Setting, 'ValueLineSpacing2', 0));
        Inc(ValueLineSpacing[3], ReadInteger(ISC_Setting, 'ValueLineSpacing3', 0));
        Inc(ValueLineSpacing[4], ReadInteger(ISC_Setting, 'ValueLineSpacing4', 0));
      end;

    finally
      Free;
    end;
  end;
end;

procedure WriteIniFile;
var
  i: Integer;
begin
  with TIniFile.Create(IniFileName) do begin
    try
      WriteString(PrjID, 'Version', VerID);

      with MainForm do begin
        WriteString(ISC_Setting, 'AdapterName', AdapterName);
        WriteFloat(ISC_Setting, 'GraphRange', GraphRange);
        WriteFloat(ISC_Setting, 'GraphMiddle', GraphMiddle);
        WriteFloat(ISC_Setting, 'GraphSendRange', GraphSendRange);
        WriteString(ISC_Setting, 'GraphUnit', GraphUnit);
        WriteBool(ISC_Setting, 'ShowValue', ShowValue);
        WriteBool(ISC_Setting, 'LockWindow', LockWindow);
        WriteBool(ISC_Setting, 'SnapWindow', SnapWindow);
        WriteBool(ISC_Setting, 'HideWindow', HideWindow);
        WriteInteger(ISC_Setting, 'AlphaBlend', AlphaBlend);
        WriteInteger(ISC_Setting, 'Interval', Interval);
        WriteInteger(ISC_Setting, 'ValueInterval', ValueInterval);

        WriteString(ISC_Color, 'Recv'  , ColorToString(clRecv  ));
        WriteString(ISC_Color, 'Send'  , ColorToString(clSend  ));
        WriteString(ISC_Color, 'Middle', ColorToString(clMiddle));
        WriteString(ISC_Color, 'Back'  , ColorToString(clBack  ));

        with CustomColors do
          for i := 0 to Count - 1 do
            // FFFFFFFF(-1)AȂȂAɂ̓JX^J[͒`ĂȂ
            if (Values[Names[i]] <> 'FFFFFFFF') and (Values[Names[i]] <> '') then
              WriteString(ISC_CustomColor, Names[i], Values[Names[i]]);

        with ValueFont do begin
          WriteString(ISC_Font, 'Name', Name);
          WriteInteger(ISC_Font, 'Size', Size);
          WriteInteger(ISC_Font, 'Style', Byte(Style));
        end;

        WriteInteger(ISC_Window, 'Top'   , Top);
        WriteInteger(ISC_Window, 'Left'  , Left);
        WriteInteger(ISC_Window, 'Width' , Width);
        WriteInteger(ISC_Window, 'Height', Height);

        Update;
      end;

    finally
      Free;
    end;
  end;
end;

end.

