(*
        lbg[N]xOt <DuGraph> (Iphlpapi.pas)
            Copyright (C) 2003-04 IGJ-HMC, all rights reserved.
*)

unit Iphlpapi;

interface

uses
  Windows;

const
  MAX_INTERFACE_NAME_LEN             = $100;
  ERROR_SUCCESS                      = 0;
  MAXLEN_IFDESCR                     = $100;
  MAXLEN_PHYSADDR                    = 8;

  MIB_IF_OPER_STATUS_NON_OPERATIONAL = 0;
  MIB_IF_OPER_STATUS_UNREACHABLE     = 1;
  MIB_IF_OPER_STATUS_DISCONNECTED    = 2;
  MIB_IF_OPER_STATUS_CONNECTING      = 3;
  MIB_IF_OPER_STATUS_CONNECTED       = 4;
  MIB_IF_OPER_STATUS_OPERATIONAL     = 5;

  MIB_IF_TYPE_OTHER                  = 1;
  MIB_IF_TYPE_ETHERNET               = 6;
  MIB_IF_TYPE_TOKENRING              = 9;
  MIB_IF_TYPE_FDDI                   = 15;
  MIB_IF_TYPE_PPP                    = 23;
  MIB_IF_TYPE_LOOPBACK               = 24;
  MIB_IF_TYPE_SLIP                   = 28;

  MIB_IF_ADMIN_STATUS_UP             = 1;
  MIB_IF_ADMIN_STATUS_DOWN           = 2;
  MIB_IF_ADMIN_STATUS_TESTING        = 3;

type
  MIB_IFROW = record
    wszName          : array[0..(MAX_INTERFACE_NAME_LEN*2-1)] of Char;
    dwIndex          : DWORD;
    dwType           : DWORD;
    dwMtu            : DWORD;
    dwSpeed          : DWORD;
    dwPhysAddrLen    : DWORD;
    bPhysAddr        : array[0..(MAXLEN_PHYSADDR-1)] of Char;
    dwAdminStatus    : DWORD;
    dwOperStatus     : DWORD;
    dwLastChange     : DWORD;
    dwInOctets       : DWORD;
    dwInUcastPkts    : DWORD;
    dwInNUcastPkts   : DWORD;
    dwInDiscards     : DWORD;
    dwInErrors       : DWORD;
    dwInUnknownProtos: DWORD;
    dwOutOctets      : DWORD;
    dwOutUcastPkts   : DWORD;
    dwOutNUcastPkts  : DWORD;
    dwOutDiscards    : DWORD;
    dwOutErrors      : DWORD;
    dwOutQLen        : DWORD;
    dwDescrLen       : DWORD;
    bDescr           : array[0..(MAXLEN_IFDESCR-1)] of Char;
  end;
  PMIB_IFROW = ^MIB_IFROW;

type
  MIB_IFTABLE = record
    dwNumEntries: DWORD;
    table: array[0..$FF] of MIB_IFROW;
  end;
  PMIB_IFTABLE = ^MIB_IFTABLE;

function GetIfTable(pIfTable: PMIB_IFTABLE; var pdwSize: ULONG; bOrder: BOOL): DWORD; stdcall;
  external 'iphlpapi.dll';

implementation

end.

