(*
        lbg[N]xOt <DuGraph> (Main.pas)
            Copyright (C) 2001-05,08-12 IGJ-HMC, all rights reserved.
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, AppEvnts, XPMan, StrUtils, Math, {Lib}HTMLHelp, {Project}Iphlpapi;

type
  TRecvSend = (Recv, Send);
  TRates = array[TRecvSend] of Integer;

type
  TMainForm = class(TForm)
    GraphImage: TImage;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    RecvRateLabel: TLabel;
    SendRateLabel: TLabel;
    PopupMenu: TPopupMenu;
    OptionItem: TMenuItem;
    N1: TMenuItem;
    ShowValueItem: TMenuItem;
    LockWindowItem: TMenuItem;
    SnapWindowItem: TMenuItem;
    HideWindowItem: TMenuItem;
    N2: TMenuItem;
    HelpItem: TMenuItem;
    AboutItem: TMenuItem;
    N3: TMenuItem;
    ExitItem: TMenuItem;
    MainTimer: TTimer;
    ApplicationEvents: TApplicationEvents;
    XPManifest: TXPManifest;
    ReshowTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure PopupMenuPopup(Sender: TObject);
    procedure OptionItemClick(Sender: TObject);
    procedure ToggleOptionItemClick(Sender: TObject);
    procedure HelpItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure MainTimerTimer(Sender: TObject);
    procedure ReshowTimerTimer(Sender: TObject);
    procedure GraphImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CreateParams(var Params: TCreateParams); override;
  private
    { Private 錾 }
    BytesPrev: TRates;                        // ȎMς݃oCg
    GraphYPrev: array[TRecvSend] of Integer;  // ÕOtW
    TickCountPrev: DWORD;
    BoundsRectPrev: TRect;
    GraphMiddleY: Integer;
    UnitDecimals: Integer;
    UnitPower: Double;
    TotalRates: TRates;           // vMoCgilϗpj
    ValueIntervalCount: Integer;  // lXVJE^
    ReduceHeight: Integer;        // k\ɂ鍂
    procedure ResetGraph;
    function GetCommRates(out Rates: TRates): Boolean;
    procedure UpdateIfTable;
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST;
  public
    { Public 錾 }
    AdapterName: String;
    AdapterIndex: Integer;
    ShowValue, LockWindow, SnapWindow, HideWindow: Boolean;
    AlphaBlend: Integer;
    Interval: Integer;
    ValueInterval: Integer;
    ValueFont: TFont;
    GraphRange, GraphMiddle, GraphSendRange: Double;
    GraphUnit: String;
    SubUnitName: Char;
    clRecv, clSend, clMiddle, clBack: TColor;
    CustomColors: TStringList;
    ValueLineSpacing: array[1..4] of Integer;
    function GetUnitPower(GraphUnit: String; out SubUnitName: Char): Double; overload;
    function GetUnitPower(GraphUnit: String): Double; overload;
    procedure DefaultHeight;
  end;

const
  // tH[ŏTCY
  MinTrackSize: TSize = (cx: 96; cy: 32);

var
  MainForm: TMainForm;
  IniFileName: TFileName;
  PIfTable: PMIB_IFTABLE;

implementation

uses Option, About, IniFile, Defines;

{$R *.DFM}
//{$DEFINE DEBUG}
//{$DEFINE DEBUG2}

procedure TMainForm.FormCreate(Sender: TObject);
var
  FindData: TWin32FindData;
  ExePath, Buf: String;
  p, i: Integer;
begin
{$IFDEF DEBUG}
  Randomize;
{$ENDIF}

  // ^̎st@Ci/̋ʂj擾
  ExePath := ExtractFilePath(ParamStr(0));
  Windows.FindClose(FindFirstFile(PChar(ParamStr(0)), FindData));
  Buf := ExtractFilePath(ParamStr(0)) + String(FindData.cFileName);

  Application.HelpFile := ChangeFileExt(Buf, '.chm');
  IniFileName := ChangeFileExt(Buf, '.ini');

  // IvVXCb`̉
  for i := 1 to ParamCount do begin
    if ParamStr(i)[1] in ['-', '/'] then begin
      p := 3;
      if ParamStr(i)[p] in ['=', ':'] then Inc(p);
      Buf := Copy(ParamStr(i), p, MaxInt);

      case AnsiLowerCase(ParamStr(i))[2] of
        // INIt@C̎w
        'i':  begin
          if ExtractFileExt(Buf) = '' then Buf := Buf + '.ini';
          if ExtractFilePath(Buf) = '' then Buf := ExePath + Buf;
          IniFileName := Buf;
        end;
      end;
    end;
  end;

  // ϐ
  CustomColors := TStringList.Create;
  ValueFont := TFont.Create;
  ValueLineSpacing[1] := RecvRateLabel.Top - Label1.BoundsRect.Bottom;
  ValueLineSpacing[2] := Label2.Top - RecvRateLabel.BoundsRect.Bottom;
  ValueLineSpacing[3] := SendRateLabel.Top - Label2.BoundsRect.Bottom;

  // lbg[NA_v^ꗗ̏
  PIfTable := nil;
  UpdateIfTable;

  // R|[lgԂ̏
  // 𑜓xݒɘAčŏEBhETCYύXȂ΂ȂȂ
  // DelphĩoOɂAWM_GETMINMAXINFO bZ[Wŏ
//Constraints.MinWidth  := Trunc(Constraints.MinWidth  * Screen.PixelsPerInch / DesignedPixelsPerInch);
//Constraints.MinHeight := Trunc(Constraints.MinHeight * Screen.PixelsPerInch / DesignedPixelsPerInch);

  // INIt@Cǂݍ
  ReadIniFile;

  // OtZbg
  // iver1.50 AEBhETCYύX ReadIniFile  FormResize Cxgɔ΂ȂȂĂj
  // i1.42 ȑO FormResize ɔł̂܂܂Ȃ̂ŁAIɌĂłׂj
  // iReadIniFile  Width ݂̒lŏƂȂĂ̂́AOtZbgsĂȂ̂悤j
  ResetGraph;

  // lbg[NA_v^ݒ莞̃bZ[W
  if AdapterName = '' then begin
    MessageBox(0, '߂Ă̋Nł̂ŁAlbg[N A_v^w̏ԂłB'#13#10 +
      'IvV _CAOJăA_v^̎wsĂB', nil, MB_ICONWARNING);

    // AvP[VCxgisĂȂƁA|C^ƉBĂ܂j
    ApplicationEvents.OnIdle := nil;
  end;

  // ɎOɕ\
  //  StH[ fsStayOnTop ɂĂ悢AuɎOɕ\Ȃv
  //  v]ƂɈꊇwł悤AApp.Handle ɎwB
  // MainForm ȊÕtH[́AAṽEBhĚ֍sƂ邪AdlƂB
  //   fsStayOnTop gĂ悤B
  SetWindowPos(Application.Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  CustomColors.Free;
  ValueFont.Free;
  FreeMem(PIfTable);
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  // ^XNo[{^iOnCreate ɏ̂ł́AĂȂj
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  WriteIniFile;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  ResetGraph;
end;

{ AvP[VAChCxgi[}EX |C^B]pj}
// ŏ́AB^ĕ\̗̃CxgōsĂABĂԂ̓ACh
// CxgC^C}ԊułȂ߁Aĕ\x邱ƂB
// B_ŕʂ100ms^C}JnAIɃAChCxg𔭐悤ɂB
procedure TMainForm.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
var
  p: TPoint;
  b: Boolean;
begin
  // ׌ŷ߁AHideWindow = false ̂Ƃ̓Cxg nil ɂĂ̂ŁAɂ͗Ȃ
//if not HideWindow then Exit;

//OutputDebugString(PChar(Format(': %s, Cxg: Idle, Reshow: %s', [FormatDateTime('hh:nn:ss.zzz', Now), BoolToStr(ReshowTimer.Enabled)])));  // fobO

  // |C^ʒu̎擾
  //  Mouse.CursorPos gƁAX^oCɁuOS @\̌Ăяo̎svG[o邱Ƃ
  // iMouse.CursorPos  GetCursorPos sĂ悤j
  if GetCursorPos(p) = false then Exit;
  b := PtInRect(BoundsRectPrev, p);

  // EBhE\̂Ƃ
  if Visible then begin
    // OEBhEʒuETCYۑ
    BoundsRectPrev := BoundsRect;

    // }EX|C^EBhEɗAEBhEBACxgp^C}Jn
    //  [Ctrl]Ăꍇ͂̂܂
    if b and (ByteBool(GetKeyState(VK_CONTROL) and $80) = false) then begin
      Hide;
      ReshowTimer.Enabled := true;
    end;
  end
  // BĂƂ
  else begin
    // |C^EBhE̊OɏoACxgp^C}~AEBhEĕ\
    if not b then begin
      ReshowTimer.Enabled := false;
      Show;
    end;
  end;
end;

{ |bvAbvj[̕\Cxg }
procedure TMainForm.PopupMenuPopup(Sender: TObject);
begin
  ShowValueItem.Checked := ShowValue;
  LockWindowItem.Checked := LockWindow;
  SnapWindowItem.Checked := SnapWindow;
  HideWindowItem.Checked := HideWindow;
end;

{ |bvAbvj[ - IvV }
procedure TMainForm.OptionItemClick(Sender: TObject);
begin
  // tH[̓I쐬
  Application.CreateForm(TOptionForm, OptionForm);
  try
    // _CAOmIꂽAOtZbg
    OptionForm.ShowModal;
    if OptionForm.ModalResult = mrOk then ResetGraph;
  finally
    OptionForm.Release;
  end;
end;

{ |bvAbvj[ - (gOݒ荀) }
procedure TMainForm.ToggleOptionItemClick(Sender: TObject);
var
  b: boolean;
begin
  // `FbNԔ]
  b := not TMenuItem(Sender).Checked;
  TMenuItem(Sender).Checked := b;

  // MenuItemI
  if Sender = ShowValueItem then
    ShowValue := b
  else if Sender = LockWindowItem then
    LockWindow := b
  else if Sender = SnapWindowItem then
    SnapWindow := b
  else { HideWindowItem }
    HideWindow := b;

  // KvɉăOtZbg
  if Sender <> LockWindowItem then ResetGraph;
end;

{ |bvAbvj[ - wv }
procedure TMainForm.HelpItemClick(Sender: TObject);
begin
  HTMLHelpContext(IDH_Main);
end;

{ |bvAbvj[ - o[W }
procedure TMainForm.AboutItemClick(Sender: TObject);
begin
  // tH[̓I쐬
  Application.CreateForm(TAboutForm, AboutForm);
  try
    AboutForm.ShowModal;
  finally
    AboutForm.Release;
  end;
end;

{ |bvAbvj[ - I }
procedure TMainForm.ExitItemClick(Sender: TObject);
begin
  Close;
end;

{ ^C}Cxg }
procedure TMainForm.MainTimerTimer(Sender: TObject);
var
  Rates: TRates;
  GraphY: array[TRecvSend] of Integer;

  { xl̕ϊ }
  function RateToStr(Rate: Integer): String;
  var
    RateD, RateMax: Double;
    Decimals: Integer;
  begin
    // \lɊZ
    RateD := Rate / UnitPower;

    // <I[o[t[h~>
    Decimals := UnitDecimals;

    while true do begin
      // _܂߂ĂUȂ̂ŁAႦ΁u0.0vݒȂA99999.9 ł͂Ȃ 9999.9 \ől
      if Decimals > 0 then
        RateMax := 99999 / IntPower(10, Decimals)
      else
        RateMax := 999999;

      // ől𒴂ĂȂΊm
      if RateD <= RateMax then Break;

      // ől𒴂Ăc
      // Ȃ΍őlŊm
      if Decimals = 0 then begin
        RateD := RateMax;
        Break;
      end
      // Ό炷
      else begin
        Dec(Decimals);
      end;
    end;

    // ɕϊA⏕Pʖt
    Result := FloatToStrF(RateD, ffFixed, 15, Decimals) + SubUnitName;
  end;

  { Ot` }
  procedure DrawGraph(GraphType: TRecvSend; GraphColor: TColor);
  var
    Range: Double;
  begin
    // MW擾
    if (GraphType = Send) and (GraphSendRange > 0) then
      Range := GraphSendRange
    else
      Range := GraphRange;

    // Ot`
    with GraphImage do begin
      Canvas.Pen.Color := GraphColor;
      GraphY[GraphType] := (ClientHeight - 1) - Trunc(Rates[GraphType] / UnitPower / Range * ClientHeight);

      // NJAŌ̂ȂƃOtE[܂ōsȂ
      Canvas.Polyline([
        Point(ClientWidth-3, GraphYPrev[GraphType]),
        Point(ClientWidth-1, GraphY[GraphType]),
        Point(ClientWidth-0, GraphY[GraphType]) ]);

      GraphYPrev[GraphType] := GraphY[GraphType];
    end;
  end;

begin
  // ̑x擾
  if GetCommRates(Rates) = false then begin
    Inc(TotalRates[Recv], Rates[Recv]);
    Inc(TotalRates[Send], Rates[Send]);

    // lXVJE^őlɂȂAl̍XV
    Inc(ValueIntervalCount);
    if ValueIntervalCount >= ValueInterval then begin
      // ϒl߂
      RecvRateLabel.Caption := RateToStr(TotalRates[Recv] div ValueInterval);
      SendRateLabel.Caption := RateToStr(TotalRates[Send] div ValueInterval);

      // ď
      TotalRates[Recv] := 0;
      TotalRates[Send] := 0;
      ValueIntervalCount := 0;
    end;
  end
  // A_v^
  else begin
    RecvRateLabel.Caption := '-';
    SendRateLabel.Caption := '-';
  end;

  // Ot`
  with GraphImage do begin
    // XN[
    Canvas.CopyRect(Rect(0, 0, ClientWidth-2, ClientHeight), Canvas, Rect(2, 0, ClientWidth, ClientHeight));
    Canvas.FillRect(Bounds(ClientWidth-2, 0, 2, ClientHeight));

    // Ԑ
    Canvas.Pen.Color := clMiddle;
    Canvas.Polyline([Point(ClientWidth-2, GraphMiddleY), Point(ClientWidth-0, GraphMiddleY)]);

    // MiMOj
    DrawGraph(Send, clSend);
    DrawGraph(Recv, clRecv);

    Canvas.Refresh;
  end;
end;

{ CEBhEĕ\p^C}Cxg}
procedure TMainForm.ReshowTimerTimer(Sender: TObject);
begin
  // Application.OnIdle Cxg100msԊuŋIɔ邾̃^C}
  { Nop };
end;

{ OtZbg }
procedure TMainForm.ResetGraph;
var
  LabelFont: TFont;
  p, i: Integer;
begin
  // EBhExݒ
  AlphaBlendValue := (100 - AlphaBlend) * 255 div 100;

  // EBhEXibvݒ
  ScreenSnap := SnapWindow;

  // ^C}Ԋuݒ
  MainTimer.Interval := Interval;

  // xl\ݒ
  Label1.Visible := ShowValue;
  Label2.Visible := ShowValue;
  SendRateLabel.Visible := ShowValue;
  RecvRateLabel.Visible := ShowValue;

  // l\
  if ShowValue then begin
    // tHg
    ValueFont.Charset := DEFAULT_CHARSET;  // tHggp\
    RecvRateLabel.Font.Assign(ValueFont);
    SendRateLabel.Font.Assign(ValueFont);

    LabelFont := TFont.Create;
    try
      LabelFont.Assign(ValueFont);
      LabelFont.Charset := SHIFTJIS_CHARSET;  // {ꕶh~
      LabelFont.Size := LabelFont.Size - 2;
      Label1.Font := LabelFont;
      Label2.Font := LabelFont;
    finally
      LabelFont.Free;
    end;

    // ʒu߂Pi_~[̃x쐬ĎwtHg̍ő啝𓾂j
    with TLabel.Create(Self) do begin
      try
        AutoSize := true;
        Font.Assign(ValueFont);
        Caption := '999999M';
        Label1.Left := RecvRateLabel.BoundsRect.Right - Width;
        Label2.Left := Label1.Left;
      finally
        Free;
      end;
    end;

    // Ot̕߂
    GraphImage.Width := Label1.Left - 10;

    // ʒu߂Q
//  Label1.Top := RecvRateLabel.BoundsRect.Bottom;
    RecvRateLabel.Top := Label1.BoundsRect.Bottom + ValueLineSpacing[1];
    Label2.Top := RecvRateLabel.BoundsRect.Bottom + ValueLineSpacing[2];
    SendRateLabel.Top := Label2.BoundsRect.Bottom + ValueLineSpacing[3];
    ReduceHeight := SendRateLabel.BoundsRect.Bottom + 7;

    // CEBhE̍W菬ȂAl\k
    if ClientHeight < ReduceHeight then begin
      Label1.Visible := false;
      Label2.Visible := false;
      RecvRateLabel.Top := 2;
      SendRateLabel.Top := RecvRateLabel.BoundsRect.Bottom + ValueLineSpacing[4];
    end;
  end
  // l\Ȃ
  else begin
    // Ot̕L
    GraphImage.Width := ClientWidth - GraphImage.Left * 2 + 1;
  end;

  Bevel1.Width := GraphImage.Width + 2;

  // OtC[W̕Ȃ肷\
  //  ܂ATImage.Picture.Bitmap.Width/Height ɕ̒lƁuVXe\[X܂v
  //  ƂȂiȂƂĈĂ??ĵŁAeKv
  if GraphImage.Width <= 2 then begin
    GraphImage.Visible := false;
    Bevel1.Visible := false;
  end
  else begin
    // OtC[W̏
    with GraphImage do begin
      Picture.BitMap.Width  := Width;
      Picture.BitMap.Height := Height;
      Canvas.Brush.Color := clBack;
      Canvas.Brush.Style := bsSolid;
      Canvas.FillRect(ClientRect);
      Canvas.Pen.Width := 1;
      Visible := true;

      GraphMiddleY := Trunc((1 - GraphMiddle / GraphRange) * ClientHeight);
      Canvas.Pen.Color := clMiddle;
      Canvas.PolyLine([Point(0, GraphMiddleY), Point(ClientWidth, GraphMiddleY)]);
    end;

    Bevel1.Visible := true;
  end;

  // lbg[NA_v^̃CfbNX擾
  AdapterIndex := 0;
  for i := 0 to PIfTable^.dwNumEntries - 1 do begin
    if AdapterName = PIfTable^.Table[i].bDescr then begin
      AdapterIndex := i;
      Break;  // Exit for
    end;
  end;

  // قɂPrev ̏
  GetCommRates(BytesPrev);
  GraphYPrev[Recv] := GraphImage.ClientHeight - 1;
  GraphYPrev[Send] := GraphImage.ClientHeight - 1;

  // lXVJE^̏
  ValueIntervalCount := 0;

  // Pʂ̏
  UnitPower := GetUnitPower(GraphUnit, SubUnitName);

  // _ȉ̌擾
  UnitDecimals := 0;
  p := Pos('.', GraphUnit) + 1;
  if p > 1 then while GraphUnit[p + UnitDecimals] = '0' do Inc(UnitDecimals);

  // ^C}ăX^[gi̕\łȒlôhj
  MainTimer.Enabled := false;
  MainTimer.Enabled := true;

  // [IvV]-[EBhE]-[}EX |C^B] ÎƂ
  //  AvP[VCxgLɁi׌yj
  if HideWindow then
    ApplicationEvents.OnIdle := ApplicationEventsIdle
  else
    ApplicationEvents.OnIdle := nil;
end;

{ ]x̎擾 }
function TMainForm.GetCommRates(out Rates: TRates): Boolean{A_v^tO};
var
  Bytes: array[TRecvSend] of Integer;
  TickCount: DWORD;
{$IFDEF DEBUG2}
var t: TextFile;
{$ENDIF}
begin
  Result := false;
  UpdateIfTable;
//Label1.Caption := IntToStr(AdapterIndex);  // A_v^̃fobO

  // A_v^ԍA_v^vȂ΁AA_v^ɂȂĂ̂ŁAZbgă^[
  //  XPł̓A_v^Ɉꗗ̂łł悢AVistał͏Ȃ̂ŕʂ̕@Kv
  //  Vł悭AVistaĽۂ̂悤Ȃ̂ŁAdlƂ
  //  WłVistaƓǏ󂪏oBOSł͂Ȃ@ɈˑǏ̂悤
  if (DWORD(AdapterIndex) >= PIfTable^.dwNumEntries) or (AdapterName <> PIfTable^.Table[AdapterIndex].bDescr) then begin
    BytesPrev[Recv] := 0;
    BytesPrev[Send] := 0;
    Rates[Recv] := 0;
    Rates[Send] := 0;

    Result := true;
    Exit;
  end;

{$IFNDEF DEBUG}
  Bytes[Recv] := PIfTable^.Table[AdapterIndex].dwInOctets;
  Bytes[Send] := PIfTable^.Table[AdapterIndex].dwOutOctets;
{$ELSE}
  Bytes[Recv] := BytesPrev[Recv] + RandomRange(50000, 100000);
  Bytes[Send] := BytesPrev[Send] + Random(5000);
{$ENDIF}

  // <xZ>
  TickCount := GetTickCount;
  if TickCount = TickCountPrev then Exit;  // ɘAČĂяoăG[ɂȂ邱Ƃ̂

  // ^C}CxgԊu͐ݒύXł̂ŁAPb̒lɕ␳
  // Integer/DWORD ̉ZŃ[jOôŁADWORDɊg
  Rates[Recv] := Trunc(DWORD(Bytes[Recv] - BytesPrev[Recv]) / (TickCount - TickCountPrev) * 1000);
  Rates[Send] := Trunc(DWORD(Bytes[Send] - BytesPrev[Send]) / (TickCount - TickCountPrev) * 1000);

{$IFDEF DEBUG2}
  AssignFile(t, 'log.txt');
  Append(t);
  Writeln(t, Format('%10d, %10d, %10d, %10d', [Rate[Recv], Rate[Send], Bytes[Recv], Bytes[Send]]));
  CloseFile(t);
{$ENDIF}

  // O̒lƂĕۑ
  BytesPrev[Recv] := Bytes[Recv];
  BytesPrev[Send] := Bytes[Send];
  TickCountPrev := TickCount;
end;

{ lbg[N̍XV }
procedure TMainForm.UpdateIfTable;
var
  d: DWORD;
begin
  d := 0;
  GetIfTable(nil, d, false);

  ReallocMem(PIfTable, d);
  ZeroMemory(PIfTable, d);
  GetIfTable(PIfTable, d, false);
end;

{ OtC[W}EX }
procedure TMainForm.GraphImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // Ot̍hbOŃEBhEړ
  if (LockWindow = false) and (Button = mbLeft) then begin
    ReleaseCapture;
    SendMessage(Handle, WM_SYSCOMMAND, SC_MOVE or $0002, MakeLParam(X, Y));
  end;
end;

procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  // BorderStyle := bsNone ƂĂAEBhEgt悤
  // iWS_DLGFRAME ȂATCYύX͂łȂj
  with Params do Style := Style or WS_THICKFRAME;
//with Params do Style := Style or WS_DLGFRAME;
end;

{ bZ[WitH[ŏTCYpj}
{ DelphĩoOɂAConstraints ͌듮삷 }
procedure TMainForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
  inherited;

//  P.X := RecvRateLabel.BoundsRect.Right - Label1.Left + 32;
//  P.Y := Label1.BoundsRect.Bottom + 8;

  // 𑜓xݒɘAčŏEBhETCYύXȂ΂ȂȂ
  with Msg.MinMaxInfo.ptMinTrackSize do begin
    X := Trunc(MinTrackSize.cx * Screen.PixelsPerInch / DesignedPixelsPerInch);
    Y := Trunc(MinTrackSize.cy * Screen.PixelsPerInch / DesignedPixelsPerInch);
  end;
end;

{ bZ[Wi}EXJ[\ύXpj }
procedure TMainForm.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  inherited;

  // [EBhEʒuETCYŒ]AIȂ΁c
  if LockWindow then begin
    // EBhE㉺EȂ΁ATCYύX֎~
    if Msg.result in [HTLEFT{10}..HTBOTTOMRIGHT{17}] then Msg.result := HTNOWHERE;
  end;
end;

{ ⏕Pʔ{ʁioCg=1Crbg=0.125CkoCg=1000Ckrbg=125C...j^⏕Pʖ擾 }
function TMainForm.GetUnitPower(GraphUnit: String; out SubUnitName: Char): Double;
const
  SubUnitNames = 'kM';
var
  i: Integer;
begin
  Result := 1;
  SubUnitName := #0;

  for i := 1 to Length(SubUnitNames) do begin
    if AnsiContainsText(GraphUnit, SubUnitNames[i]) then begin
      Result := IntPower(1000, i);
      SubUnitName := SubUnitNames[i];
      Break;  // Exit for
    end;
  end;

  // oCgrbg ̕ϊ
  if AnsiContainsText(GraphUnit, 'rbg') then Result := Result / 8;
end;

function TMainForm.GetUnitPower(GraphUnit: String): Double;
var c: Char;
begin
  Result := GetUnitPower(GraphUnit, c);
end;

{ ̍ɖ߂ }
procedure TMainForm.DefaultHeight;
begin
  ClientHeight := ReduceHeight;
end;

end.

