(*
        lbg[N]xOt <DuGraph> (Option.pas)
            Copyright (C) 2002-05,08-12 IGJ-HMC, all rights reserved.
*)

unit Option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, CommCtrl{TUpDown}, {Lib}HTMLHelp, {Project}Iphlpapi;

type
  TOptionForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    HelpBtn: TButton;
    AdapterGroup: TGroupBox;
    AdapterBox: TComboBox;
    GraphGroup: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    GraphRangeEdit: TEdit;
    GraphMiddleEdit: TEdit;
    GraphSendRangeEdit: TEdit;
    GraphUnitBox: TComboBox;
    RecvColorBtn: TButton;
    RecvColorShape: TShape;
    SendColorBtn: TButton;
    SendColorShape: TShape;
    MiddleColorBtn: TButton;
    MiddleColorShape: TShape;
    BackColorBtn: TButton;
    BackColorShape: TShape;
    ColorDlg: TColorDialog;
    WindowGroup: TGroupBox;
    ShowValueCheck: TCheckBox;
    LockWindowCheck: TCheckBox;
    SnapWindowCheck: TCheckBox;
    HideWindowCheck: TCheckBox;
    Label5: TLabel;
    AlphaBlendEdit: TEdit;
    AlphaBlendUpDown: TUpDown;
    Label52: TLabel;
    Label6: TLabel;
    IntervalEdit: TEdit;
    IntervalUpDown: TUpDown;
    Label62: TLabel;
    Label7: TLabel;
    ValueIntervalEdit: TEdit;
    ValueIntervalUpDown: TUpDown;
    Label72: TLabel;
    ValueFontButton: TButton;
    DefaultHeightBtn: TButton;
    FontDlg: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GraphUnitBoxSelect(Sender: TObject);
    procedure ColorBtnClick(Sender: TObject);
    procedure UpDownEditExit(Sender: TObject);
    procedure ValueFontButtonClick(Sender: TObject);
    procedure DefaultHeightBtnClick(Sender: TObject);
    procedure LockWindowCheckClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private 錾 }
    GraphUnitPrev: String;
  public
    { Public 錾 }
  end;

var
  OptionForm: TOptionForm;

implementation

uses Main, Defines;

{$R *.DFM}

procedure TOptionForm.FormCreate(Sender: TObject);
var
  PhysicalAddresses: array of Int64;
  i: Integer;
begin
  // xẃAWin2000ȍ~̂
  if not CheckWin32Version(5) then begin
    Label5.Enabled := false;
    Label52.Enabled := false;
    AlphaBlendEdit.Enabled := false;
  end;

  // lbg[NA_v^ꗗ
  SetLength(PhysicalAddresses, PIfTable^.dwNumEntries);
  AdapterBox.Sorted := true;
  for i := 0 to PIfTable^.dwNumEntries - 1 do begin
    AdapterBox.Items.Add(PIfTable^.Table[i].bDescr);
  end;

  // ݂̃A_v^łAꗗɒǉi\[g𖳌ɂĈԉցj
  if (MainForm.AdapterName <> '') and (AdapterBox.Items.IndexOf(MainForm.AdapterName) = -1) then begin
    AdapterBox.Sorted := false;
    AdapterBox.Items.Add(MainForm.AdapterName);
  end;

  // ݂̃A_v^I
  AdapterBox.ItemIndex := AdapterBox.Items.IndexOf(MainForm.AdapterName);

  // ݒlRs[
  GraphRangeEdit.Text := FloatToStr(MainForm.GraphRange);
  GraphMiddleEdit.Text := FloatToStr(MainForm.GraphMiddle);
  GraphSendRangeEdit.Text := FloatToStr(MainForm.GraphSendRange);
  GraphUnitBox.ItemIndex := GraphUnitBox.Items.IndexOf(MainForm.GraphUnit);

  RecvColorShape.Brush.Color   := MainForm.clRecv;
  SendColorShape.Brush.Color   := MainForm.clSend;
  MiddleColorShape.Brush.Color := MainForm.clMiddle;
  BackColorShape.Brush.Color   := MainForm.clBack;
  ColorDlg.CustomColors := MainForm.CustomColors;

  ShowValueCheck.Checked := MainForm.ShowValue;
  LockWindowCheck.Checked := MainForm.LockWindow;
  SnapWindowCheck.Checked := MainForm.SnapWindow;
  HideWindowCheck.Checked := MainForm.HideWindow;
  AlphaBlendUpDown.Position := MainForm.AlphaBlend;
  IntervalUpDown.Position := MainForm.Interval;
  ValueIntervalUpDown.Position := MainForm.ValueInterval;

  FontDlg.Font.Assign(MainForm.ValueFont);

  // 
  GraphUnitPrev := GraphUnitBox.Text;
end;

{ tH[\CxgiTUpDown̉ݒj}
procedure TOptionForm.FormShow(Sender: TObject);
var
  UpDowns: array[1..3] of TUpDown;  // const ɂ͂łȂ
  UDAccel: array[1..2] of TUDAccel;
  i: Integer;
begin
  // TUpDown.Increment ̐ݒ㏑AQbɂT{Ƃ
  UpDowns[1] := AlphaBlendUpDown;
  UpDowns[2] := IntervalUpDown;
  UpDowns[3] := ValueIntervalUpDown;

  for i := Low(UpDowns) to High(UpDowns) do begin
    UpDowns[i].Perform(UDM_GETACCEL, 1, LPARAM(@UDAccel));
    UDAccel[2].nSec := 2;
    UDAccel[2].nInc := UDAccel[1].nInc * 5;
    UpDowns[i].Perform(UDM_SETACCEL, 2, LPARAM(@UDAccel));
  end;
end;

{ Pʂ̕ύXiAĐݒlύXj}
procedure TOptionForm.GraphUnitBoxSelect(Sender: TObject);
var
  Rate: Double;
begin
  Rate := MainForm.GetUnitPower(GraphUnitPrev) / MainForm.GetUnitPower(GraphUnitBox.Text);

  GraphRangeEdit.Text := FloatToStr(StrToFloat(GraphRangeEdit.Text) * Rate);
  GraphMiddleEdit.Text := FloatToStr(StrToFloat(GraphMiddleEdit.Text) * Rate);
  GraphSendRangeEdit.Text := FloatToStr(StrToFloat(GraphSendRangeEdit.Text) * Rate);

  GraphUnitPrev := GraphUnitBox.Text;
end;

{ FύX{^ }
procedure TOptionForm.ColorBtnClick(Sender: TObject);
var
  Shape: TShape;
begin
  // ShapeI
  if Sender = RecvColorBtn then
    Shape := RecvColorShape
  else if Sender = SendColorBtn then
    Shape := SendColorShape
  else if Sender = MiddleColorBtn then
    Shape := MiddleColorShape
  else { BackColorBtn }
    Shape := BackColorShape;

  // R_CAOŐFύX
  ColorDlg.Color := Shape.Brush.Color;
  ColorDlg.Execute;
  Shape.Brush.Color := ColorDlg.Color;
end;

{ TUpDownɊ֘AtꂽTEdit }
procedure TOptionForm.UpDownEditExit(Sender: TObject);
begin
  // l͈͊OłĂ͈͓ɖ߂
  if Sender = AlphaBlendEdit then
    AlphaBlendEdit.Text := IntToStr(AlphaBlendUpDown.Position)
  else if Sender = IntervalEdit then
    IntervalEdit.Text := IntToStr(IntervalUpDown.Position)
  else { ValueIntervalUpDown }
    ValueIntervalEdit.Text := IntToStr(ValueIntervalUpDown.Position);
end;

{ [ltHg...] {^ }
procedure TOptionForm.ValueFontButtonClick(Sender: TObject);
begin
  FontDlg.Execute;
end;

{ [̍ɖ߂]{^ }
procedure TOptionForm.DefaultHeightBtnClick(Sender: TObject);
begin
  DefaultHeightBtn.Enabled := false;
  MainForm.DefaultHeight;
end;

procedure TOptionForm.LockWindowCheckClick(Sender: TObject);
begin
  // [ʒuETCYŒ]IȂÃ_CAOύXs
  DefaultHeightBtn.Enabled := not LockWindowCheck.Checked;
end;

{ [OK] }
procedure TOptionForm.OKBtnClick(Sender: TObject);
var
  RangeEdits: array[1..3] of TEdit;  // const ɂ͂łȂ
  i: Integer;
begin
  // lbg[NA_v^̃`FbN
  if AdapterBox.ItemIndex = -1 then begin
    MessageBox(Handle, 'lbg[N A_v^w肵ĂB', nil, MB_ICONERROR);
    AdapterBox.SetFocus;
    Exit;
  end;

  // Wl̃`FbN
  RangeEdits[1] := GraphRangeEdit;
  RangeEdits[2] := GraphMiddleEdit;
  RangeEdits[3] := GraphSendRangeEdit;

  for i := Low(RangeEdits) to High(RangeEdits) do begin
    try
      StrToFloat(RangeEdits[i].Text);
    except
      MessageBox(Handle, 'l𐳂w肵ĂB', nil, MB_ICONERROR);
      RangeEdits[i].SetFocus;
      Exit;
    end;
  end;

  // ݒl߂
  MainForm.AdapterName := AdapterBox.Text;

  MainForm.GraphRange := StrToFloat(GraphRangeEdit.Text);
  MainForm.GraphMiddle := StrToFloat(GraphMiddleEdit.Text);
  MainForm.GraphSendRange := StrToFloat(GraphSendRangeEdit.Text);
  MainForm.GraphUnit := GraphUnitBox.Text;

  MainForm.clRecv   := RecvColorShape.Brush.Color;
  MainForm.clSend   := SendColorShape.Brush.Color;
  MainForm.clMiddle := MiddleColorShape.Brush.Color;
  MainForm.clBack   := BackColorShape.Brush.Color;
  MainForm.CustomColors.Assign(ColorDlg.CustomColors);

  MainForm.ShowValue := ShowValueCheck.Checked;
  MainForm.LockWindow := LockWindowCheck.Checked;
  MainForm.SnapWindow := SnapWindowCheck.Checked;
  MainForm.HideWindow := HideWindowCheck.Checked;
  MainForm.AlphaBlend := AlphaBlendUpDown.Position;
  MainForm.Interval := IntervalUpDown.Position;
  MainForm.ValueInterval := ValueIntervalUpDown.Position;

  MainForm.ValueFont.Assign(FontDlg.Font);

  // mI
  ModalResult := mrOk;
end;

{ [wv] }
procedure TOptionForm.HelpBtnClick(Sender: TObject);
begin
  HTMLHelpContext(IDH_Option);
end;

end.

